package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class NutrientesPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By selecionarOpcaoNutrientes = By.xpath("//section[@class='something-else']//span[text() = 'Nutrientes']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@data-zh-id=\"232554219839611045356\"]//div[@class=\"zh-test-box\"]");
    By campoCodigo = By.id("CDNUTRIENTE");
    By campoNome = By.id("NMNUTRIENTE");
    By campoSigla = By.id("NMREDUZIDO");
    By campoUn = By.id("SGUNIDADE");
    By campoOrdem = By.id("NRORDEMNUTR");
    By campoGruppo = By.id("NMGRUPNUTR");
    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"232554219269003067337\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNome = By.xpath("//div[@data-zh-id=\"2325542191218599811341\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSigla = By.xpath("//div[@data-zh-id=\"2325542193883671384342\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUn = By.xpath("//div[@data-zh-id=\"2325542191924533084343\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioOrdem = By.xpath("//div[@data-zh-id=\"2325542192973821237346\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupo = By.xpath("//div[@data-zh-id=\"2325542193009240775347\"]//div[@class=\"zh-validation\"]/span");

    By botaoLimparUn = By.xpath("//div[@id='SGUNIDADE']//span[@zh-icon=\"no-border close-x\"]");
    By botaoPesquisarUn = By.xpath("//div[@id='SGUNIDADE']//span[@zh-icon=\"no-border search\"]");
    By campoProcurarProdutoFinal = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By unMiligrama = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'MILIGRAMA']");
    By unMiligramaCapsula = By.xpath("//div[@data-zh-id=\"2325542191924533084343\"]//span[text() = 'MG/CAP | MILIGRAMA/CAPSULA']");

    By botaoSalvar = By.xpath("//div[@id=\"footer\"]//span[text() = 'Salvar']");
    By grupoGorduras = By.xpath("//div[@data-zh-id='2325542193009240775347']//span[text() = '03 | GORDURAS']");
    By grupoSais = By.xpath("//div[@data-zh-id='2325542193009240775347']//span[text() = '06 | SAIS MINERAIS']");

    By botaoEditarUltimoNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[13]//div[@class=\"zh-grid-actions\"]//span[@zh-icon=\"pencil no-border inline-block\"]");
    By botaoExcluirTerceiroNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[3]//div[@class=\"zh-grid-actions\"]//span[@zh-icon=\"trash no-border inline-block\"]");
    By nomeTerceiroNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[3]/div[3]/span");
    By nomePenultimoNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[12]/div[3]/span");

    By botaoExcluirUltimoNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[13]//div[@class=\"zh-grid-actions\"]//span[@zh-icon=\"trash no-border inline-block\"]");
    By botaExcluirPenultimoNutriente = By.xpath("//div[@id=\"grid-232554219152514048336\"]//div[@class=\"body-content\"]/div[12]//div[@class=\"zh-grid-actions\"]//span[@zh-icon=\"trash no-border inline-block\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");

    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Nutrientes");
        click(selecionarOpcaoNutrientes);
    }

    public void adicionarNutriente() {
        tempo();
        tempo();
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "40");
        sendKeys(campoNome, "LIPÍDIOS");
        sendKeys(campoSigla, "LIP");
        click(botaoPesquisarUn);
        sendKeys(campoProcurarProdutoFinal, "MILIGRAMA");
        click(unMiligrama);
        clicarCampoSelecionarValor(campoGruppo, grupoGorduras);
        click(botaoSalvar);
    }

    public void verificarDadosAdicionados() {
        tempo();
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-232554219152514048336 > div.grid-vertical-scroll-control\").scrollBy(0, 400)");
        tempo();
        click(botaoEditarUltimoNutriente);
        tempo();

        //dados encontrados
        String encCodigo = driver.findElement(campoCodigo).getAttribute("value");
        String encNome = driver.findElement(campoNome).getAttribute("value");
        String encSigla = driver.findElement(campoSigla).getAttribute("value");
        String encUnidade = getText(campoUn);
        String encOrdem = driver.findElement(campoOrdem).getAttribute("value");
        String encGrupo = getText(campoGruppo);

        //valores esperados
        String expCodigo = "040";
        String expNome = "LIPÍDIOS";
        String expSigla = "LIP";
        String expUnidade = "MG";
        String expOrdem = "22";
        String expGrupo = "GORDURAS";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do nutriente adicionado");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do nutriente adicionado");
        Assert.assertEquals(encSigla, expSigla, "Verificação da sigla do nutriente adicionado");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade do nutriente adicionado");
        Assert.assertEquals(encOrdem, expOrdem, "Verificação da ordem do nutriente adicionado");
        Assert.assertEquals(encGrupo, expGrupo, "Verificação do grupo do nutriente adicionado");

        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void editarNutrienteAdicionado() {
        tempo();
        click(botaoEditarUltimoNutriente);
        tempo();
        clearAndSendKeys(campoNome, "IODO");
        clearAndSendKeys(campoSigla,"I");
        clicarCampoSelecionarValor(campoUn, unMiligramaCapsula);
        clearAndSendKeys(campoOrdem, "30");
        clicarCampoSelecionarValor(campoGruppo, grupoSais);

        click(botaoSalvar);
        tempo();
        click(botaoVoltar);
    }

    public void verificarDadosEditados() {
        tempo();
        click(botaoEditarUltimoNutriente);
        tempo();

        //dados encontrados
        String encCodigo = driver.findElement(campoCodigo).getAttribute("value");
        String encNome = driver.findElement(campoNome).getAttribute("value");
        String encSigla = driver.findElement(campoSigla).getAttribute("value");
        String encUnidade = getText(campoUn);
        String encOrdem = driver.findElement(campoOrdem).getAttribute("value");
        String encGrupo = getText(campoGruppo);

        //valores esperados
        String expCodigo = "040";
        String expNome = "IODO";
        String expSigla = "I";
        String expUnidade = "MG/CAP";
        String expOrdem = "30";
        String expGrupo = "SAIS MINERAIS";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do nutriente após a edição");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do nutriente após a edição");
        Assert.assertEquals(encSigla, expSigla, "Verificação da sigla do nutriente após a edição");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade do nutriente após a edição");
        Assert.assertEquals(encOrdem, expOrdem, "Verificação da ordem do nutriente após a edição");
        Assert.assertEquals(encGrupo, expGrupo, "Verificação do grupo do nutriente após a edição");

        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void excluirNutriente() {
        tempo();
        click(botaoExcluirUltimoNutriente);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após clicar no botao excluir nutriente");
        click(botaoSim);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de excluído com sucesso, após a exclusão do nutriente");
    }

    public void camposObrigatorios() {
        click(botaoAdicionar);
        clear(campoOrdem);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A ordem não deve ser decimal.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida na tela após limpar o campo ordem");
        click(botaoOk);
        tempo();
        click(botaoSalvar);

        //mensagens encontrados nos campo obrigatórios
        String codigo = getText(mensagemObrigatorioCodigo);
        String nome = getText(mensagemObrigatorioNome);
        String sigla = getText(mensagemObrigatorioSigla);
        String unidade = getText(mensagemObrigatorioUn);
        String ordem = getText(mensagemObrigatorioOrdem);
        String grupo = getText(mensagemObrigatorioGrupo);

        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo código");
        Assert.assertEquals(nome, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo nome");
        Assert.assertEquals(sigla, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo sigla");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo unidade");
        Assert.assertEquals(ordem, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo ordem");
        Assert.assertEquals(grupo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo grupo");
    }

    public void adicionarCodigoExistente() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoNome, "LIPÍDIOS");
        sendKeys(campoSigla, "LIP");
        click(botaoPesquisarUn);
        sendKeys(campoProcurarProdutoFinal, "MILIGRAMA");
        click(unMiligrama);
        clicarCampoSelecionarValor(campoGruppo, grupoGorduras);
        click(botaoSalvar);

        //mensagem alerta de código já existente
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentar adicionar um código já existente");
        click(botaoOk);
    }

    public void tentarExcluirNutrRegisFilho() {
        click(botaoExcluirTerceiroNutriente);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida após clicar no botao excluir nutriente");
        click(botaoSim);

        mensagem = getText(mensagemAlerta);
        mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida informando que o nutriente não pode ser excluído");
        click(botaoOk);

        String nutriente = getText(nomeTerceiroNutriente);
        String nutrienteEsperado = "VITAMINA D";
        Assert.assertEquals(nutriente, nutrienteEsperado, "Verificando se o nutriente que possuí registro filhos não foi removido");
    }

    public void alterarOrdem() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-232554219152514048336 > div.grid-vertical-scroll-control\").scrollBy(0, 400)");
        click(botaoEditarUltimoNutriente);
        clearAndSendKeys(campoOrdem, "21");
        click(botaoSalvar);
        tempo();
        click(botaoVoltar);
        tempo();
        tempo();

        String nutriente = getText(nomePenultimoNutriente);
        String nutrienteEsperado = "LIPÍDIOS";
        Assert.assertEquals(nutriente, nutrienteEsperado, "Verificando se a ordem dos nutrientes foi alterada");

        click(botaExcluirPenultimoNutriente);
        click(botaoSim);

        tempo();
        click(botaoEditarUltimoNutriente);
        clearAndSendKeys(campoOrdem, "21");
        click(botaoSalvar);
    }

}
