package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class RequisicaoServicoAnaliticaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaRequisicaoServicoAnalitica = By.xpath("//span[text() = 'Requisição por Serviço Analítica']");

    By campoRelatorio = By.xpath("//div[@data-zh-id='102434461418014814015284']//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioPorServico = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (por Serviço)']");
    By relatorioTurnosPorServico = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (Turnos Por Serviço)']");
    By relatorioGrupoDeServico = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (por Grupo de Serviço)']");
    By relatorioModoDePreparo = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (com Modo de Preparo)']");
    By relatorioTipoDePrato = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (por Tipo de Prato/Prato)']");
    By relatorioProducao = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (Produção)']");
    By relatorioProducaoPorGrupoDeServico = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (Produção por Grupo de Serviço)']");
    By relatorioProducaoGeral = By.xpath("//div[@class='zh-select-native-div']//ul[@class='list zh-new-select-list']//li[text() = 'Requisição Analítica (Produção Geral)']");

    By botaoFecharCampoData = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@zh-icon=\"no-border close-x\"]");
    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");

    By botaoCampoUniade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");

    By todosGrupoServicos = By.xpath("//div[@data-zh-id='102434461414427207105296']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoGrupoServico = By.id("CDGRUPSERV");
    By grupoServicoPedidos = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'PEDIDOS']");
    By grupoServicoEntregas = By.xpath("//div[@data-zh-field-name=\"NMGRUPSERV\"]//span[text() = 'ENTREGAS']");

    By todoServicos = By.xpath("//div[@data-zh-id='10243446147739468285302']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.id("NMSERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");

    By botaoOk = By.xpath("//section[@id='popup']//span[text() = 'Ok']");
    By campoPercentualAcressimo = By.id("PEACRESCIMO");

    By checkBoxQuebraPagina = By.xpath("//label[@for=\"zh-checkbox-QUEBRAPAG\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxImprimirLinhasBranco = By.xpath("//label[@for=\"zh-checkbox-LINHABR\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxImprimirModePreparoPadrao = By.xpath("//label[@for=\"zh-checkbox-IMPMODOPREPARO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxArredondarQuantProd = By.xpath("//label[@for=\"zh-checkbox-ARREDQTD\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxCardapio = By.xpath("//label[@for=\"zh-checkbox-CARDAPIO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxConsumoFixo = By.xpath("//label[@for=\"zh-checkbox-CONSUMOFIX\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxConsumoPerCapita = By.xpath("//label[@for=\"zh-checkbox-CONSUMOPERCAP\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");

    By inputCheckQuebraPagina = By.id("zh-checkbox-QUEBRAPAG");
    By inputImprimirLinhasBranco = By.id("zh-checkbox-LINHABR");
    By inputImprimirModoPreparoPadrao = By.id("zh-checkbox-IMPMODOPREPARO");
    By inputArredondaQuantProd = By.id("zh-checkbox-ARREDQTD");
    By inputCheckCardapio = By.id("zh-checkbox-CARDAPIO");
    By inputCheckConsumoFixo = By.id("zh-checkbox-CONSUMOFIX");
    By inputCheckConsumoPerCapita = By.id("zh-checkbox-CONSUMOPERCAP");

    By campoQuantLinhasBranco = By.id("QTDLINHAS");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By mensagemObrigatorioData = By.xpath("//div[@data-zh-id=\"102434461425482987781977\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"10243446148512080205288\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioGrupoServico = By.xpath("//div[@data-zh-id=\"102434461412521121025292\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"102434461440480456015298\"]//div[@class=\"zh-validation\"]/span");

    By mensagemObrigatorioAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button");

    By radioButtonOrdenacaoCodigo = By.xpath("//label[@for=\"radio-ORDENACAO-Código\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By radioButtonOrdenacaoAlfabeticaNivel = By.xpath("//label[@for=\"radio-ORDENACAO-Alfabética Pelo Nível\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By inputOrdenacaoCodigo = By.id("radio-ORDENACAO-Código");
    By inputOrdenacaoAlfabeticaNivel = By.id("radio-ORDENACAO-Alfabética Pelo Nível");

    By campoNivelOrdenacaoHabilitado = By.xpath("//div[@data-zh-id=\"10243446141932948125316\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By campoNivelOrdenacaoDesabilitado = By.xpath("//div[@data-zh-id=\"10243446141932948125316\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\" and @readonly=\"readonly\"]");
    By niveisOrdenacao = By.xpath("//div[@data-zh-id=\"10243446141932948125316\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By nivelOrdenacaoSelecionado = By.xpath("//div[@data-zh-id=\"10243446141932948125316\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Requisição por Serviço Analítica");
        click(telaRequisicaoServicoAnalitica);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        if (nomeDoRelatorio == "Requisição Analítica (por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioPorServico);
        } else if (nomeDoRelatorio == "Requisição Analítica (Turnos Por Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioTurnosPorServico);
        } else if (nomeDoRelatorio == "Requisição Analítica (por Grupo de Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioGrupoDeServico);
        } else if (nomeDoRelatorio == "Requisição Analítica (com Modo de Preparo)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioModoDePreparo);
        } else if (nomeDoRelatorio == "Requisição Analítica (por Tipo de Prato/Prato)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioTipoDePrato);
        } else if (nomeDoRelatorio == "Requisição Analítica (Produção)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProducao);
        } else if (nomeDoRelatorio == "Requisição Analítica (Produção por Grupo de Serviço)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioProducaoPorGrupoDeServico);
        } else if (nomeDoRelatorio == "Requisição Analítica (Produção Geral)") {
            click(campoRelatorio);
            tempo();
            javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section:nth-child(1) > div > div:nth-child(1) > div > div > div.new-select.input-text.form-input-margin-bottom.mousetrap.form-control.zh-text-align-\\\\{\\\\{field\\\\.align.\\\\|\\\\|.\\\\'left\\\\'\\\\}\\\\}.ng-pristine.ng-untouched.ng-valid.open > ul\").scrollTop = 50");
            click(relatorioProducaoGeral);
        }
    }

    public void selecionarGrupoServico() {
        click(todosGrupoServicos);
        click(campoGrupoServico);
        click(grupoServicoPedidos);
        click(grupoServicoEntregas);
        click(botaoOk);
    }

    public void selecionarServico() {
        click(todoServicos);
        click(campoServico);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void preencherPercentualAcressimo() {
        Actions actions = new Actions(driver);
        clearAndSendKeys(campoPercentualAcressimo, "15");
        actions.moveToElement(driver.findElement(campoPercentualAcressimo), 0, -25).click().build().perform();
        String encAcressimo = driver.findElement(campoPercentualAcressimo).getAttribute("value");
        String expAcressimo = "15,00";
        Assert.assertEquals(encAcressimo, expAcressimo, "Verificar se o valor inserido no campo percentual de acréssimo, ficou salvo corretamente");
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void verificarCheckBoxs() {
        boolean quebraPagina = returnIfElementIsSelected(inputCheckQuebraPagina);
        boolean imprimirLinhasBranco = returnIfElementIsSelected(inputImprimirLinhasBranco);
        boolean arredondarQuantProdutos = returnIfElementIsSelected(inputArredondaQuantProd);
        boolean cardapio = returnIfElementIsSelected(inputCheckCardapio);
        boolean consumoFixo = returnIfElementIsSelected(inputCheckConsumoFixo);
        boolean consumoPercapita = returnIfElementIsSelected(inputCheckConsumoPerCapita);

        Assert.assertEquals(quebraPagina, true, "Verificar se a opção 'quebra de página' já está selecionada no momente de carregamento da página");
        Assert.assertEquals(imprimirLinhasBranco, false, "Verificar se a opção 'imprimir linhas em branco' já está selecionada no momente de carregamento da página");
        Assert.assertEquals(arredondarQuantProdutos, false, "Verificar se a 'arredondar qtde. de produtos' de página já está selecionada no momente de carregamento da página");
        Assert.assertEquals(cardapio, true, "Verificar se a opção 'cardápio' já está selecionada no momente de carregamento da página");
        Assert.assertEquals(consumoFixo, true, "Verificar se a opção 'consumo fixo' já está selecionada no momente de carregamento da página");
        Assert.assertEquals(consumoPercapita, true, "Verificar se a opção 'consumo per capita' já está selecionada no momente de carregamento da página");

        click(checkBoxQuebraPagina);
        click(checkBoxImprimirLinhasBranco);
        click(checkBoxArredondarQuantProd);
        click(checkBoxCardapio);
        click(checkBoxConsumoFixo);
        click(checkBoxConsumoPerCapita);

        quebraPagina = returnIfElementIsSelected(inputCheckQuebraPagina);
        imprimirLinhasBranco = returnIfElementIsSelected(inputImprimirLinhasBranco);
        arredondarQuantProdutos = returnIfElementIsSelected(inputArredondaQuantProd);
        cardapio = returnIfElementIsSelected(inputCheckCardapio);
        consumoFixo = returnIfElementIsSelected(inputCheckConsumoFixo);
        consumoPercapita = returnIfElementIsSelected(inputCheckConsumoPerCapita);

        Assert.assertEquals(quebraPagina, false, "Verificar se a opção 'quebra de página' não está mais selecionada após clicar na mesma");
        Assert.assertEquals(imprimirLinhasBranco, true, "Verificar se a opção 'imprimir linhas em branco' passa a estar selecionada após clicar na mesma");
        Assert.assertEquals(arredondarQuantProdutos, true, "Verificar se a 'arredondar qtde. de produtos' passa a estar selecionada após clicar na mesma");
        Assert.assertEquals(cardapio, false, "Verificar se a opção 'cardápio' não está mais selecionada após clicar na mesma");
        Assert.assertEquals(consumoFixo, false, "Verificar se a opção 'consumo fixo' não está mais selecionada após clicar na mesma");
        Assert.assertEquals(consumoPercapita, false, "Verificar se a opção 'consumo per capita' não está mais selecionada após clicar na mesma");
    }

    public void verificarQuantLinhasBranco() {
        boolean imprimirLinhasBranco = returnIfElementIsSelected(inputImprimirLinhasBranco);
        boolean campoQuantLinhasEmBranco = returnIfElementIsEnabled(campoQuantLinhasBranco);
        Assert.assertEquals(imprimirLinhasBranco, false, "Verificar se o check-box 'Imprimir Linhas em Branco' não está selecionado");
        Assert.assertEquals(campoQuantLinhasEmBranco, false, "Verificar se o campo de quantidade linhas em branco está desabilitado quando o check-box 'Imprimir Linhas em Branco' não está selecionado");

        click(checkBoxImprimirLinhasBranco);
        imprimirLinhasBranco = returnIfElementIsSelected(inputImprimirLinhasBranco);
        campoQuantLinhasEmBranco = returnIfElementIsEnabled(campoQuantLinhasBranco);
        Assert.assertEquals(imprimirLinhasBranco, true, "Verificar se o check-box 'Imprimir Linhas em Branco' está selecionado");
        Assert.assertEquals(campoQuantLinhasEmBranco, true, "Verificar se o campo de quantidade linhas em branco está habilitado quando o check-box 'Imprimir Linhas em Branco' está selecionado");

        Actions actions = new Actions(driver);
        clearAndSendKeys(campoQuantLinhasBranco, "3");
        actions.moveToElement(driver.findElement(campoPercentualAcressimo), 0, -25).click().build().perform();
        String quantLinhasBranco = driver.findElement(campoQuantLinhasBranco).getAttribute("value");
        Assert.assertEquals(quantLinhasBranco, "3", "Verificar se o valor adicionado ao campo de quantidade de linhas em branco foi adicionado corretamente");
    }

    public void verificarCampoObrigatorios() {
        click(botaoFecharCampoData);
        click(botaoCampoUniade);
        click(todosGrupoServicos);
        click(todoServicos);
        click(botaoRelatorio);

        String data = getText(mensagemObrigatorioData);
        String unidade = getText(mensagemObrigatorioUnidade);
        String grupoServicos = getText(mensagemObrigatorioGrupoServico);
        String servicos = getText(mensagemObrigatorioServico);

        String mensagemEsperadaData = "Start and End date is Required!";
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(data, mensagemEsperadaData, "Verificação da mensagem de campo obrigatório no campo 'data'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(grupoServicos, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'grupo de serviços'");
        Assert.assertEquals(servicos, mensagemEsperada, "Verificação da mensagem de campo obrigatório no campo 'serviços'");

        click(checkBoxCardapio);
        click(checkBoxConsumoFixo);
        click(checkBoxConsumoPerCapita);
        click(botaoRelatorio);

        String mensagemAlerta = getText(mensagemObrigatorioAlerta);
        mensagemEsperada = "Opção de impressão deve ser informada";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exibida na tela quando uma opção de impressão não é selecionada");
        click(botaoOkAlerta);
    }

    public void verificarOrdenacao() {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 200)");

        boolean ordencacaoCodigo = returnIfElementIsSelected(inputOrdenacaoCodigo);
        boolean ordencaoAlfaticaNivel = returnIfElementIsSelected(inputOrdenacaoAlfabeticaNivel);
        boolean campoNivel = returnIfElementExists(campoNivelOrdenacaoDesabilitado);
        Assert.assertEquals(ordencacaoCodigo, true, "Verificar se a ordenação por 'código' já está selecionada ao carregar a tela");
        Assert.assertEquals(ordencaoAlfaticaNivel, false, "Verificar se a ordenação 'alfabética pelo nível' não está selecionada ao carregar a tela");
        Assert.assertEquals(campoNivel, true, "Verificar se quando a ordenação 'código' está selecionada, o campo nível está desabilitado");

        click(radioButtonOrdenacaoAlfabeticaNivel);
        ordencacaoCodigo = returnIfElementIsSelected(inputOrdenacaoCodigo);
        ordencaoAlfaticaNivel = returnIfElementIsSelected(inputOrdenacaoAlfabeticaNivel);
        campoNivel = returnIfElementExists(campoNivelOrdenacaoHabilitado);
        Assert.assertEquals(ordencacaoCodigo, false, "Verificar se a ordenação por 'código' não está mais selecionada ao clicar na ordenação 'alfabética pelo nível'");
        Assert.assertEquals(ordencaoAlfaticaNivel, true, "Verificar se a ordenação 'alfabética pelo nível' passa a estar selecioanda ao clicar na mesma");
        Assert.assertEquals(campoNivel, true, "Verificar se o campo 'nível' passa a estar habilitado quando a ordenação 'alfabética pelo nível' está selecionada");

        verificarNiveis();
    }

    private void verificarNiveis() {
        click(campoNivelOrdenacaoHabilitado);
        tempo();

        long timeout = 0;
        List<WebElement> results = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                niveisOrdenacao
                        )
                );

        int quantNiveis = 0;
        for (WebElement nivel : results) {
            Assert.assertEquals(nivel.getText(), String.valueOf(quantNiveis));
            quantNiveis++;
        }
        Assert.assertEquals(results.size(), 6, "Verificar se a quantidade total de níveis corresponde à 6");
        results.get(2).click();
        String nivelSelecionado = getText(nivelOrdenacaoSelecionado);
        Assert.assertEquals(nivelSelecionado, "2", "Verificar o valor do nível selecionado");
    }

}
